﻿using UnityEngine;
using System.Collections;

public class Dataport<T>
{
	public T data;
	private int refCount;

	public DataportReturn Register(string id)
	{
		return DataportManager.Instance.Add(id, this);
	}

	public DataportReturn DeRegister()
	{
		return DataportManager.Instance.Remove(this);
	}

	public Dataport<T> Attach(string id)
	{
		Dataport<T> returnVal = (Dataport<T>)DataportManager.Instance.Attach(id);
		if(returnVal != null)
		{
			this.refCount++;
		}
		return returnVal;
	}

	public DataportReturn Detach()
	{
		DataportReturn returnVal = DataportManager.Instance.Detach(this);

		if(returnVal == DataportReturn.DATAPORT_SUCCESS)
		{
			this.refCount--;
		}

		return returnVal;
	}

	public int GetRefCount()
	{
		return this.refCount;
	}
}
